export class Main extends Indicator {

    constructor() {
        super();

        this.setProperty(Property.SeparateWindow, true);
        this.setProperty(Property.ShortName, "AO");

        this.addInput("PriceType", InputType.PriceType, PriceType.Bid);

        this.buffers = {
            ExtBuffer1 : this.addBuffer(),
            ExtBuffer2 : this.addBuffer(),
        };

        this.arr = {
            ExtBuffer0: [],
        }
    }

    onInit() {
        this.buffers.ExtBuffer1
            .setShape(Shape.Histogram)
            .setColor(Color.Green)

            .setDigits(Current.Digits+1)
            .setDrawBegin(34)
        ;

        this.buffers.ExtBuffer2
            .setShape(Shape.Histogram)
            .setColor(Color.Red)

            .setDigits(Current.Digits+1)
            .setDrawBegin(34)
        ;
    }

    async onUpdate() {
        const {PriceType} = this.getInputs(),
            {ExtBuffer1, ExtBuffer2} = this.buffers,
            {ExtBuffer0} = this.arr,
            {High, Low} = await Bar.load([Bar.Mode.High, Bar.Mode.Low], PriceType),
            barSize = High.length;

        let limit, prev, current, i, up, list1, list2,
            countedBars = Bar.counted();

        if (countedBars > 0) {
            countedBars--;
        }

        limit = barSize - countedBars;

        list1 = await Indicators.MA(null, 0, 5, 0, Averaging.Simple, AppliedPrice.Median, PriceType);
        list2 = await Indicators.MA(null, 0, 34, 0, Averaging.Simple, AppliedPrice.Median, PriceType);

        for (i = 0; i < limit; i++) {
            ExtBuffer0[i] = list1[i] - list2[i];
        }

        up = true;

        for (i = limit - 1; i >= 0; i--) {
            current = ExtBuffer0[i];
            prev = ExtBuffer0[(i + 1)];
            if (current > prev) {
                up = true;
            }
            if (current < prev) {
                up = false;
            }

            if (!up) {
                ExtBuffer2.set(i, current);
                ExtBuffer1.set(i, 0);
            }
            else {
                ExtBuffer1.set(i, current);
                ExtBuffer2.set(i, 0);
            }
        }
    }
}